package com.hkbyte.edufinger.ef_videoplayer;

import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.OrientationEventListener;
import android.view.View;
import android.view.WindowManager;
import android.widget.Toast;


import androidx.appcompat.app.AppCompatActivity;

import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.PlayerConstants;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.YouTubePlayer;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.listeners.AbstractYouTubePlayerListener;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.listeners.YouTubePlayerFullScreenListener;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.listeners.YouTubePlayerListener;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.utils.YouTubePlayerTracker;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.views.YouTubePlayerView;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.ui.PlayerUiController;

import java.util.Observable;


public class EfLibPlayerActivity extends AppCompatActivity {
    YouTubePlayerTracker tracker;
    YouTubePlayerFullScreenListener fullScreenListener;
    float currentTime;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ef_lib_player);

        View decorView = getWindow().getDecorView();
        // Calling setSystemUiVisibility() with a value of 0 clears
        // all flags.
        decorView.setSystemUiVisibility(0);
        this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,WindowManager.LayoutParams.FLAG_FULLSCREEN);

        final String videoId = getIntent().getStringExtra("videoId");
        Log.d("Video ID", videoId);
        OrientationEventListener orientationEventListener = new OrientationEventListener(getWindow().getContext()) {
            @Override
            public void onOrientationChanged(int orientation) {

            }
        };


        final YouTubePlayerView youTubePlayerView = findViewById(R.id.youtube_player_view);
        final PlayerUiController uiController = youTubePlayerView.getPlayerUiController();
        uiController.showFullscreenButton(true);

        youTubePlayerView.enableBackgroundPlayback(false);

        youTubePlayerView.addYouTubePlayerListener(new AbstractYouTubePlayerListener() {
            @Override
            public void onReady(final YouTubePlayer youTubePlayer) {
                super.onReady(youTubePlayer);
                if(videoId!=null) {
                    youTubePlayer.loadVideo(videoId, 0);
                    youTubePlayer.play();
                }

                tracker = new YouTubePlayerTracker();
                fullScreenListener = new YouTubePlayerFullScreenListener() {
                    @SuppressLint("SourceLockedOrientationActivity")
                    @Override
                    public void onYouTubePlayerEnterFullScreen() {
                        youTubePlayer.pause();
                        youTubePlayer.seekTo(tracker.getCurrentSecond());
                        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_LANDSCAPE);
                        youTubePlayer.play();
                    }

                    @SuppressLint("SourceLockedOrientationActivity")
                    @Override
                    public void onYouTubePlayerExitFullScreen() {
                        youTubePlayer.pause();
                        youTubePlayer.seekTo(tracker.getCurrentSecond());
                        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_SENSOR_PORTRAIT);
                        youTubePlayer.play();
                    }
                };
                youTubePlayer.addListener(tracker);

            }
        });
        getLifecycle().addObserver(youTubePlayerView);
    }
}