package com.hkbyte.edufinger.ef_videoplayer;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.view.View;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.platform.PlatformView;


import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.PlayerConstants;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.YouTubePlayer;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.listeners.YouTubePlayerListener;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.player.views.YouTubePlayerView;
import com.pierfrancescosoffritti.androidyoutubeplayer.core.ui.PlayerUiController;


import static io.flutter.plugin.common.MethodChannel.MethodCallHandler;


public class FlutterWeb implements PlatformView, MethodCallHandler {

    private final TextView textView;
    YouTubePlayerView youTubePlayerView;
    YouTubePlayer globalYouTubePlayer;

    Context context;
    Registrar registrar;
    WebView webView;
    String url = "";
    MethodChannel channel;


    @SuppressLint("SetJavaScriptEnabled")
    FlutterWeb(Context context, Registrar registrar, int id) {
        this.context = context;
        this.registrar = registrar;
        this.url = url;


        textView = new TextView(context);
        textView.setText("Demo Here");
        webView = getWebView(registrar);
        youTubePlayerView = new YouTubePlayerView(context);
        PlayerUiController uiController= youTubePlayerView.getPlayerUiController();
        uiController.showYouTubeButton(false);
        uiController.showMenuButton(false);

        youTubePlayerView.addYouTubePlayerListener(new YouTubePlayerListener() {
            @Override
            public void onReady(YouTubePlayer youTubePlayer) {
                globalYouTubePlayer = youTubePlayer;

//                youTubePlayer.loadVideo("JFYCc577kjQ",0);
            }

            @Override
            public void onStateChange(YouTubePlayer youTubePlayer, PlayerConstants.PlayerState playerState) {

            }

            @Override
            public void onPlaybackQualityChange(YouTubePlayer youTubePlayer, PlayerConstants.PlaybackQuality playbackQuality) {

            }

            @Override
            public void onPlaybackRateChange(YouTubePlayer youTubePlayer, PlayerConstants.PlaybackRate playbackRate) {

            }

            @Override
            public void onError(YouTubePlayer youTubePlayer, PlayerConstants.PlayerError playerError) {

            }

            @Override
            public void onCurrentSecond(YouTubePlayer youTubePlayer, float v) {

            }

            @Override
            public void onVideoDuration(YouTubePlayer youTubePlayer, float v) {

            }

            @Override
            public void onVideoLoadedFraction(YouTubePlayer youTubePlayer, float v) {

            }

            @Override
            public void onVideoId(YouTubePlayer youTubePlayer, String s) {

            }

            @Override
            public void onApiChange(YouTubePlayer youTubePlayer) {

            }
        });

        channel = new MethodChannel(registrar.messenger(), "ef_videoplayer");

        channel.setMethodCallHandler(this);
    }


    @Override
    public View getView() {
//        return webView;
//        return youTubePlayerView;
        return textView;
    }

    @Override
    public void dispose() {

    }

    private WebView getWebView(Registrar registrar) {
        WebView webView = new WebView(registrar.context());
        webView.setWebViewClient(new WebViewClient());
        webView.getSettings().setJavaScriptEnabled(true);

        return webView;
    }

    @Override
    public void onMethodCall(MethodCall call, MethodChannel.Result result) {
        switch (call.method) {
            case "loadUrl":
                String url = call.arguments.toString();
                webView.loadUrl(url);
                break;
            case "startPlayer":
                String videoId = call.arguments.toString();
                Intent intent = new Intent(registrar.activity(), EfPlayerActivity.class);
                registrar.activity().startActivity(intent);
                break;
            case "startLibPlayer":
                String libVideoId = call.arguments.toString();
                Intent libIntent = new Intent(registrar.activity(), EfLibPlayerActivity.class);
                libIntent.putExtra("videoId", libVideoId);
                registrar.activity().startActivity(libIntent);
                break;
            default:
                result.notImplemented();
        }

    }


}
