import 'dart:async';
import 'package:flutter/foundation.dart';
import 'package:flutter/services.dart';
import 'package:flutter/material.dart';


class EFVideoplayer extends StatefulWidget {


  EFVideoplayer({
    Key key,
  });

  @override
  _FfVideoPlayepState createState() => _FfVideoPlayepState();
}

class _FfVideoPlayepState extends State<EFVideoplayer> {
  @override
  Widget build(BuildContext context) {
    if(defaultTargetPlatform == TargetPlatform.android) {
      return AndroidView(
        viewType: 'ef_videoplayer',
        onPlatformViewCreated: onPlatformViewCreated,
        creationParamsCodec: const StandardMessageCodec(),
      );
    } else if(defaultTargetPlatform == TargetPlatform.iOS) {
      return UiKitView(
        viewType: 'ef_videoplayer',
        onPlatformViewCreated: onPlatformViewCreated,
        creationParamsCodec: const StandardMessageCodec(),
      );
    }

    return new Text('$defaultTargetPlatform is not yet supported by this plugin');
  }

  Future<void> onPlatformViewCreated(id) async {
    
  }

}


class EfVideoPlayerController {

  MethodChannel _channel;
  
  EfVideoPlayerController() {
    _channel =  new MethodChannel('ef_videoplayer');
  }
  
  Future<void> loadVideo(String videoId) async {
    assert(videoId != null);
    return _channel.invokeMethod('startLibPlayer', videoId);
  }
}